Package com.documentum.fc.client

# Interface IDfGroup

All Superinterfaces:
  `IDfPersistentObject`, `IDfTypedObject`

public interface IDfGroup extends IDfPersistentObject
This interface provides access to group-related data stored in group objects.

- ## Field Summary

  ### Fields inherited from interface com.documentum.fc.client.IDfPersistentObject

  `CURRENCY_CHECK_ALWAYS, CURRENCY_CHECK_FIRST_ACCESS, CURRENCY_CHECK_NEVER, CURRENCY_CHECK_ONCE_PER_SCOPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `addGroup(String groupName)`
  Adds a group to this group.
  `boolean`
  `addUser(String userName)`
  Adds a user to this group.
  `IDfId`
  `getAliasSetId()`
  Returns the alias set object id of the group.
  `String`
  `getAllUsersNames(int index)`
  Returns the name (at a specified index) from all users in a group object, including users that belong to group objects contained within this group object.
  `int`
  `getAllUsersNamesCount()`
  Returns the number of users in a group object, including users that belong to group objects contained within this group object.
  `String`
  `getDescription()`
  Returns the user-defined description of a group object.
  `boolean`
  `getDynamic()`
  Gets the dynamic setting of this group
  `boolean`
  `getDynamicDefault()`
  Gets the default membership setting for the dynamic group.
  `String`
  `getGroupAddress()`
  Returns the electronic mail address for a group object.
  `String`
  `getGroupAdmin()`
  Gets the admin of this group.
  `String`
  `getGroupClass()`
  Gets the class of this gruop.
  `IDfId`
  `getGroupDirectoryId()`
  `String`
  `getGroupDisplayName()`
  Gets the display name of a group.
  `String`
  `getGroupGlobalUniqueId()`
  `String`
  `getGroupName()`
  Returns the name of a group object.
  `IDfId`
  `getGroupNativeRoomId()`
  Gets the group native room id.
  `IDfCollection`
  `getGroupsNames()`
  Returns a collection of group members' names in this group.
  `String`
  `getGroupsNames(int index)`
  Returns the name of a group that is a member in a group object at the specified index.
  `int`
  `getGroupsNamesCount()`
  Returns the number of groups that are users in a group object.
  `String`
  `getGroupSource()`
  `boolean`
  `getHasEvents()`
  `IDfTime`
  `getModifyDate()`
  Returns the time and date that a group object was last modified.
  `String`
  `getOwnerName()`
  Returns the user name of the user who created a group object.
  `String`
  `getSupergroupsNames(int index)`
  `int`
  `getSupergroupsNamesCount()`
  `IDfCollection`
  `getUsersNames()`
  Returns a collection of user members' names in this group.
  `String`
  `getUsersNames(int index)`
  Returns the name of the user in a group object at a specified index.
  `int`
  `getUsersNamesCount()`
  Returns the number of users in a Group object.
  `boolean`
  `isGloballyManaged()`
  Indicates whether the ACL associated with a group object is globally or locally managed.
  `boolean`
  `isGroupInGroup(String groupName)`
  Determines whether the group is one of the members of this group.
  `boolean`
  `isPrivate()`
  Indicates whether a group object is private or public.
  `boolean`
  `isUserInGroup(String userName)`
  Determines whether the user is one of the members of this group.
  `void`
  `removeAllGroups()`
  Removes all groups from this group.
  `void`
  `removeAllUsers()`
  Removes all users from this group.
  `boolean`
  `removeGroup(String groupName)`
  Add a group to this group.
  `boolean`
  `removeUser(String userName)`
  Removes a user to this group.
  `void`
  `renameGroup(String groupName, boolean isImmediate, boolean unlockObjects, boolean reportOnly)`
  Rename this group.
  `void`
  `renameGroupEx(String groupName, boolean isImmediate, boolean unlockObjects, boolean reportOnly, String groupDisplayName)`
  Rename this group.
  `void`
  `setAliasSetId(IDfId aliasId)`
  Sets the alias set object id of the group.
  `void`
  `setDescription(String description)`
  Sets the description of this group.
  `void`
  `setDynamic(boolean isDynamic)`
  Marks the group as a dynamic group
  `void`
  `setDynamicDefault(boolean isDynamicDefault)`
  Marks the dynamic group as having its membership be included by default for members when they connect.
  `void`
  `setGloballyManaged(boolean isGloballyManaged)`
  Sets if this group is globally managed (by Federation) or local.
  `void`
  `setGroupAddress(String groupAddress)`
  Sets the e-mail address of this group.
  `void`
  `setGroupAdmin(String admin)`
  Sets the admin of this group.
  `void`
  `setGroupClass(String className)`
  Sets the class of this group.
  `void`
  `setGroupDirectoryId(IDfId value)`
  `void`
  `setGroupDisplayName(String value)`
  Sets the display name of a group.
  `void`
  `setGroupGlobalUniqueId(String value)`
  `void`
  `setGroupName(String groupName)`
  Sets the name of this group.
  `void`
  `setGroupNativeRoomId(IDfId value)`
  Sets the group native room id.
  `void`
  `setGroupSource(String value)`
  `void`
  `setOwnerName(String ownerName)`
  Sets the owner of this group.
  `void`
  `setPrivate(boolean isPrivate)`
  Sets if this group is private or public

  ### Methods inherited from interface com.documentum.fc.client.IDfPersistentObject

  `addChildRelative, addParentRelative, apiExec, apiGet, apiSet, destroy, fetch, fetchWithCaching, getAttrAssistance, getAttrAssistanceWithValues, getAttrAsstDependencies, getChildRelatives, getParentRelatives, getPartition, getType, getValidator, getVStamp, getWidgetType, isDeleted, isDirty, isInstanceOf, isNew, isReplica, lock, lockEx, registerEvent, removeChildRelative, removeParentRelative, revert, save, setPartition, signoff, unRegisterEvent, unRegisterEventEx, validateAllRules, validateAttrRules, validateAttrRulesWithValue, validateAttrRulesWithValues, validateObjRules, validateObjRulesWithValues`

  ### Methods inherited from interface com.documentum.fc.client.IDfTypedObject

  `appendBoolean, appendDouble, appendId, appendInt, appendString, appendTime, appendValue, dump, enumAttrs, findAttrIndex, findBoolean, findDouble, findId, findInt, findString, findTime, findValue, getAllRepeatingStrings, getAttr, getAttrCount, getAttrDataType, getBoolean, getDouble, getId, getInt, getLong, getObjectId, getObjectSession, getOriginalSession, getRepeatingBoolean, getRepeatingDouble, getRepeatingId, getRepeatingInt, getRepeatingLong, getRepeatingString, getRepeatingTime, getRepeatingValue, getSession, getSessionManager, getString, getTime, getValue, getValueAt, getValueCount, hasAttr, insertBoolean, insertDouble, insertId, insertInt, insertString, insertTime, insertValue, isAttrRepeating, isNull, remove, removeAll, setBoolean, setDouble, setId, setInt, setNull, setRepeatingBoolean, setRepeatingDouble, setRepeatingId, setRepeatingInt, setRepeatingString, setRepeatingTime, setRepeatingValue, setSessionManager, setString, setTime, setValue, truncate`

- ## Method Details

  - ### getOwnerName

    String getOwnerName() throws DfException
    Returns the user name of the user who created a group object.
    Throws:
      `DfException` - if a server error occurs

  - ### getGroupName

    String getGroupName() throws DfException
    Returns the name of a group object.
    Throws:
      `DfException` - if a server error occurs

  - ### getGroupAddress

    String getGroupAddress() throws DfException
    Returns the electronic mail address for a group object.
    Throws:
      `DfException` - if a server error occurs

  - ### getUsersNames

    String getUsersNames(int index) throws DfException
    Returns the name of the user in a group object at a specified index.
    Throws:
      `DfException` - if a server error occurs

  - ### getUsersNamesCount

    int getUsersNamesCount() throws DfException
    Returns the number of users in a Group object.
    Throws:
      `DfException` - if a server error occurs

  - ### getGroupsNames

    String getGroupsNames(int index) throws DfException
    Returns the name of a group that is a member in a group object at the specified index.
    Throws:
      `DfException` - if a server error occurs

  - ### getGroupsNamesCount

    int getGroupsNamesCount() throws DfException
    Returns the number of groups that are users in a group object.
    Throws:
      `DfException` - if a server error occurs

  - ### isPrivate

    boolean isPrivate() throws DfException
    Indicates whether a group object is private or public.
    Throws:
      `DfException` - if a server error occurs

  - ### getDescription

    String getDescription() throws DfException
    Returns the user-defined description of a group object.
    Throws:
      `DfException` - if a server error occurs

  - ### getAllUsersNames

    String getAllUsersNames(int index) throws DfException
    Returns the name (at a specified index) from all users in a group object, including users that belong to group objects contained within this group object.
    Throws:
      `DfException` - if a server error occurs

  - ### getAllUsersNamesCount

    int getAllUsersNamesCount() throws DfException
    Returns the number of users in a group object, including users that belong to group objects contained within this group object.
    Throws:
      `DfException` - if a server error occurs

  - ### isGloballyManaged

    boolean isGloballyManaged() throws DfException
    Indicates whether the ACL associated with a group object is globally or locally managed.

    A globally managed ACL can only be edited in the governing repository. See the Distributed Configuration Guide for more information about distributed repositories.
    Throws:
      `DfException` - if a server error occurs

  - ### getModifyDate

    IDfTime getModifyDate() throws DfException
    Returns the time and date that a group object was last modified.

    If the group has not been modified, this method specifies the group's creation date.
    Throws:
      `DfException` - if a server error occurs

  - ### getAliasSetId

    IDfId getAliasSetId() throws DfException
    Returns the alias set object id of the group.

    Refer to Server Fundamentals for more information about aliases.
    Throws:
      `DfException` - if a server error occurs.

  - ### setAliasSetId

    void setAliasSetId(IDfId aliasId) throws DfException
    Sets the alias set object id of the group.

    Refer to Server Fundamentals for more information about aliases.
    Throws:
      `DfException` - if a server error occurs.

  - ### isUserInGroup

    boolean isUserInGroup(String userName) throws DfException
    Determines whether the user is one of the members of this group.
    Parameters:
      `userName` - user name of the user
    Throws:
      `DfException`

  - ### isGroupInGroup

    boolean isGroupInGroup(String groupName) throws DfException
    Determines whether the group is one of the members of this group.
    Parameters:
      `groupName` - group name of the group
    Throws:
      `DfException`

  - ### renameGroup

    void renameGroup(String groupName, boolean isImmediate, boolean unlockObjects, boolean reportOnly) throws DfException
    Rename this group. This method shall invoke a job to do the operation
    Throws:
      `DfException`

  - ### renameGroupEx

    void renameGroupEx(String groupName, boolean isImmediate, boolean unlockObjects, boolean reportOnly, String groupDisplayName) throws DfException
    Rename this group. This method takes an extra param groupDisplayName and invokes a job to do the operation
    Throws:
      `DfException` - if an error occurs.
    Since:
      D6

  - ### setGroupName

    void setGroupName(String groupName) throws DfException
    Sets the name of this group.

    The name has to be unique in the repository, throw DfException otherwise.
    Parameters:
      `groupName` - name of this group to be renamed to
    Throws:
      `DfException`

  - ### setGroupAddress

    void setGroupAddress(String groupAddress) throws DfException
    Sets the e-mail address of this group.
    Parameters:
      `groupAddress` - e-mail address of this group
    Throws:
      `DfException`

  - ### setDescription

    void setDescription(String description) throws DfException
    Sets the description of this group.
    Parameters:
      `description` - description of this group.
    Throws:
      `DfException`

  - ### setPrivate

    void setPrivate(boolean isPrivate) throws DfException
    Sets if this group is private or public
    Parameters:
      `isPrivate` - `true` If this group is private. `false` If this group is public.
    Throws:
      `DfException`

  - ### setOwnerName

    void setOwnerName(String ownerName) throws DfException
    Sets the owner of this group. If the connected user is not a superuser, an exception is thrown because non-superuser does not have enough privilege to set the owner name.
    Parameters:
      `ownerName` - owner name of this group.
    Throws:
      `DfException`

  - ### setGloballyManaged

    void setGloballyManaged(boolean isGloballyManaged) throws DfException
    Sets if this group is globally managed (by Federation) or local.
    Parameters:
      `isGloballyManaged` - `true` If this group is managed by Federation. `false` If this group is manged locally.
    Throws:
      `DfException`

  - ### addUser

    boolean addUser(String userName) throws DfException
    Adds a user to this group. If the user already exists in this group, no exception is thrown.
    Parameters:
      `userName` - name of a user to be added.
    Returns:
      True if the user was not in this group and the user is added.
    Throws:
      `DfException`

  - ### addGroup

    boolean addGroup(String groupName) throws DfException
    Adds a group to this group. If the group already exists in this group, no exception is thrown.
    Parameters:
      `groupName` - name of a group to be added.
    Returns:
      True if the group was not in this group and the group is added.
    Throws:
      `DfException`

  - ### removeUser

    boolean removeUser(String userName) throws DfException
    Removes a user to this group. If the user does not exist in this group, no exception is thrown.
    Parameters:
      `userName` - name of a user to be removed.
    Returns:
      True if the user was in this group.
    Throws:
      `DfException`

  - ### removeGroup

    boolean removeGroup(String groupName) throws DfException
    Add a group to this group. If the group does not exist in this group, no exception is thrown.
    Parameters:
      `groupName` - name of a group to be removed.
    Returns:
      True if the group was in this group.
    Throws:
      `DfException`

  - ### removeAllUsers

    void removeAllUsers() throws DfException
    Removes all users from this group.
    Throws:
      `DfException`

  - ### removeAllGroups

    void removeAllGroups() throws DfException
    Removes all groups from this group.
    Throws:
      `DfException`

  - ### getUsersNames

    IDfCollection getUsersNames() throws DfException
    Returns a collection of user members' names in this group.

    The caller is responsible to close the collection.
    Returns:
      IDfCollection of user members' names in this group. Each row of the collection contains the 'users_names' attribute.
    Throws:
      `DfException` - if a server error occurs

  - ### getGroupsNames

    IDfCollection getGroupsNames() throws DfException
    Returns a collection of group members' names in this group.

    The caller is responsible to close the collection.
    Returns:
      IDfCollection of group members' names in this group. Each row of the collection contains the 'groups_names' attribute.
    Throws:
      `DfException` - if a server error occurs

  - ### setGroupClass

    void setGroupClass(String className) throws DfException
    Sets the class of this group.
    Parameters:
      `className` - The class of this group.
    Throws:
      `DfException`

  - ### getGroupClass

    String getGroupClass() throws DfException
    Gets the class of this gruop.
    Returns:
      The class of this group.
    Throws:
      `DfException`

  - ### setGroupAdmin

    void setGroupAdmin(String admin) throws DfException
    Sets the admin of this group.
    Parameters:
      `admin` - The admin of this group. If this is not a valid group, an exception is thrown.
    Throws:
      `DfException`

  - ### getGroupAdmin

    String getGroupAdmin() throws DfException
    Gets the admin of this group.
    Returns:
      The admin of this group.
    Throws:
      `DfException`

  - ### setDynamic

    void setDynamic(boolean isDynamic) throws DfException
    Marks the group as a dynamic group
    Parameters:
      `isDynamic` - `true` If this group is dynamic. `false` If this group is not dynamic.
    Throws:
      `DfException`
    Since:
      5.2.10

  - ### getDynamic

    boolean getDynamic() throws DfException
    Gets the dynamic setting of this group
    Returns:
      `true` if the group is a dynamic group; `false` if the group is not.
    Throws:
      `DfException`
    Since:
      5.2.10

  - ### setDynamicDefault

    void setDynamicDefault(boolean isDynamicDefault) throws DfException
    Marks the dynamic group as having its membership be included by default for members when they connect.
    Parameters:
      `isDynamicDefault` - `true` If this group's membership is default. `false` If this group's membership is not default.
    Throws:
      `DfException`
    Since:
      5.2.10

  - ### getDynamicDefault

    boolean getDynamicDefault() throws DfException
    Gets the default membership setting for the dynamic group.
    Returns:
      `true` if the group's dynamic_default flag is on; `false` if the dynamic_default flag is not on.
    Throws:
      `DfException`
    Since:
      5.2.10

  - ### getSupergroupsNamesCount

    int getSupergroupsNamesCount() throws DfException
    Throws:
      `DfException`

  - ### getSupergroupsNames

    String getSupergroupsNames(int index) throws DfException
    Throws:
      `DfException`

  - ### getGroupSource

    String getGroupSource() throws DfException
    Throws:
      `DfException`

  - ### setGroupSource

    void setGroupSource(String value) throws DfException
    Throws:
      `DfException`

  - ### getHasEvents

    boolean getHasEvents() throws DfException
    Throws:
      `DfException`

  - ### getGroupGlobalUniqueId

    String getGroupGlobalUniqueId() throws DfException
    Throws:
      `DfException`

  - ### setGroupGlobalUniqueId

    void setGroupGlobalUniqueId(String value) throws DfException
    Throws:
      `DfException`

  - ### getGroupNativeRoomId

    IDfId getGroupNativeRoomId() throws DfException
    Gets the group native room id.
    Returns:
      the group native room id
    Throws:
      `DfException` - if a server error occurs

  - ### setGroupNativeRoomId

    void setGroupNativeRoomId(IDfId value) throws DfException
    Sets the group native room id.
    Throws:
      `DfException` - if a server error occurs

  - ### getGroupDirectoryId

    IDfId getGroupDirectoryId() throws DfException
    Throws:
      `DfException`

  - ### setGroupDirectoryId

    void setGroupDirectoryId(IDfId value) throws DfException
    Throws:
      `DfException`

  - ### getGroupDisplayName

    String getGroupDisplayName() throws DfException
    Gets the display name of a group.
    Throws:
      `DfException` - if a server error occurs

  - ### setGroupDisplayName

    void setGroupDisplayName(String value) throws DfException
    Sets the display name of a group.
    Throws:
      `DfException` - if a server error occurs